package com.logicbig.example;

import org.primefaces.model.menu.*;

import javax.annotation.PostConstruct;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.ViewScoped;

/**
 * This class tries to add nested mega columns but that doesn't work
 */
@ManagedBean
@ViewScoped
public class MenuBean2 {
    private MenuModel model = new DefaultMenuModel();
    private DefaultSubMenu rootMenu;

    @PostConstruct
    public void init() {
        rootMenu = new DefaultSubMenu("Main Menu");
        model.addElement(rootMenu);
        addMenu("File", "New", "Open", "Close", "Exit");
        addMenu("Edit", "Undo", "Redo", "Cut", "Copy");
        addMenu(addMenu("View", "Summary"), "Tools", "Settings", "Layout");
        addMenu("Help", "Help topics", "Support");
    }

    public DefaultSubMenu addMenu(String label, String... items) {
        return addMenu(null, label, items);
    }

    public DefaultSubMenu addMenu(DefaultSubMenu parentMenu,
                                  String label, String... items) {
        DefaultMenuColumn column = new DefaultMenuColumn();
        DefaultSubMenu theColumnMenu = new DefaultSubMenu(label);
        column.addElement(theColumnMenu);

        for (Object item : items) {
            DefaultMenuItem mi = new DefaultMenuItem(item);
            mi.setUrl("#");
            theColumnMenu.addElement(mi);
        }
        if (parentMenu == null) {
            rootMenu.addElement(column);

        } else {
            //it doesn't work.. looks like adding nested sub menu is not supported
            parentMenu.addElement(theColumnMenu);
            //following doesn't work either
            // parentMenu.addElement(column);
        }
        return theColumnMenu;
    }

    public MenuModel getMenuModel() {
        return model;
    }
}